clear; clc;
%% solution to Q9

% state-space model
A = [-0.0028 0.0389 0 -32.1740;
     -0.065 -0.317  769.2960 0;
     0.0002 -0.001 -0.4272 0;
     0 0 1.0 0];
B = [1.44 0.0008;
     -17.90 -0.0002;
     -1.1579 0;
     0 0];
 
 %% design controller
 f = [1;0];  % Q 9.b
 %f = [0;1]  % Q 9.c

% desired poles
 p1 = -0.06 + 0.06*1i;
 p2 = -0.06 - 0.06*1i;
 p3 = -4;
 p4 = -5;
 
% compute Q
Q = [(p1 * eye(4) - A)^(-1)*B*f,(p2 * eye(4) - A)^(-1)*B*f, ...
     (p3 * eye(4) - A)^(-1)*B*f,(p4 * eye(4) - A)^(-1)*B*f]'
Qinv = Q^(-1)
k = Q^(-1)*(-ones(4,1))
K = f*k'

eig(A - B*K)
imag(K)
